/**
 * @file
 * Iconify Icons plugin.
 */

// eslint-disable-next-line func-names
(function ($, Drupal, CKEDITOR) {
  CKEDITOR.plugins.add('iconify_icons', {
    icons: 'iconify_icons',
    init(editor) {
      // Add the dialog command.
      editor.addCommand('iconify_icons', {
        modes: { wysiwyg: 1 },
        canUndo: true,
        // eslint-disable-next-line no-shadow
        exec(editor) {
          // Fired when saving the dialog.
          const saveCallback = function saveCallback(returnValues) {
            const settings = returnValues.settings || false;
            if (!settings) return;
            editor.fire('saveSnapshot');

            const selection = editor.getSelection();
            const range = selection.getRanges(1)[0];

            // eslint-disable-next-line new-cap
            const container = new CKEDITOR.dom.element('i', editor.document);

            container.addClass('iconify-icons');

            // Add other classes.
            if (settings.classes !== '') {
              container.addClass(settings.classes);
            }
            container.setText(settings.icon);

            range.insertNode(container);
            range.select();

            editor.fire('saveSnapshot');
          };

          const dialogSettings = {
            dialogClass: 'iconify-icons-dialog',
          };

          // Open the entity embed dialog for corresponding EmbedButton.
          Drupal.ckeditor.openDialog(
            editor,
            Drupal.url('iconify_icons/dialog'),
            {},
            saveCallback,
            dialogSettings,
          );
        },
      });

      // UI Button
      editor.ui.addButton('iconify_icons', {
        label: 'Insert Iconify Icons',
        command: 'iconify_icons',
        icon: `${this.path}icons/iconify_icons.png`,
      });
    },
  });
  // eslint-disable-next-line no-undef
})(jQuery, Drupal, CKEDITOR);
